//Marius Nicoli
#include <stdio.h>
#define P1 3
#define P2 5

long long N, i, j, x, y;

long long transf(long long x, long long b) {
	long long r = 0;
	long long p = 1LL;
	while (x) {
		if (x%2 == 1LL) {
			r+=p;
		}
		x/=2;
		p*=b;
	}
	return r;
}

int main(){
	FILE *f = fopen("puteri35.in","r");
	fscanf(f,"%I64d",&N);
	fclose(f);
	
	FILE *g = fopen("puteri35.out","w");
	
	i = 1;
	x = transf(i, P1);
	j = 1;
	y = transf(j, P2);
	while (i<=N && j<=N) {
		if (x<=y) {
			fprintf(g,"%I64d\n",x);
			x = transf(++i, P1);
		} else {
			fprintf(g,"%I64d\n",y);
			y = transf(++j, P2);
		}
	}
	
	for (;i<=N;i++) {
		fprintf(g,"%I64d\n",x);
		x = transf(i+1, P1);
	}
	
	for (;j<=N;j++) {
		fprintf(g,"%I64d\n",y);
		y = transf(j+1, P2);
	}
		
	
	fclose(g);
	return 0;
}
