/*
 * Author: Cosmin Gheorghe
 * Bulaneala
 */

#include <stdio.h>
#include <stdlib.h>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;

#define NMAX 100010
#define LL long long

#define MP make_pair
#define ff first
#define ss second

#define LIM 100

int N, M;

set <pair<int ,int> > Hx, Hy;

int xc[NMAX], yc[NMAX], rc[NMAX];
int xp[NMAX], yp[NMAX];

int rez[NMAX];

int verif(int p, int c)
{
	LL dst = (LL) (xc[c] - xp[p]) * (xc[c] - xp[p]) + (LL) (yc[c] - yp[p]) * (yc[c] - yp[p]);

	return dst <= (LL) rc[c] * rc[c];
}

int main()
{
	int i;

	freopen("nuke.in", "r", stdin);
	freopen("nuke.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= N; i++) 
		scanf("%d %d", &xp[i], &yp[i]);

	for (i = 1; i <= M; i++) {
		scanf("%d %d %d", &xc[i], &yc[i], &rc[i]);
		Hx.insert(MP(xc[i], i));
		Hy.insert(MP(yc[i], i));
	}

	for (i = 1; i <= N; i++) {
		set <pair<int, int> > :: iterator its = Hx.upper_bound(MP(xp[i], 0)), it;

		set <int> cr; cr.clear();

		int np = 0; it = its;
		while (np <= LIM) {
			if (it != Hx.end()) if(verif(i, it->ss)) cr.insert(it->ss);

			if (it != Hx.begin()) --it;
			else break;
			np++;
		}

		np = 0; it = its;
		while (np <= LIM) {
			if (it != Hx.end()) { if(verif(i, it->ss)) cr.insert(it->ss); }
			else break;

			++it;
			np++;
		}

		its = Hy.upper_bound(MP(yp[i], 0));

		np = 0; it = its;
		while (np <= LIM) {
			if (it != Hy.end()) if(verif(i, it->ss)) cr.insert(it->ss);

			if (it != Hy.begin()) --it;
			else break;
			np++;
		}

		np = 0; it = its;
		while (np <= LIM) {
			if (it != Hy.end()) { if(verif(i, it->ss)) cr.insert(it->ss); }
			else break;

			++it;
			np++;
		}

		for (set <int> :: iterator it = cr.begin(); it != cr.end(); ++it) rez[*it]++;
	}

	for (i = 1; i <= M; i++) printf("%d\n", rez[i]);
//	system("./brut\n");

	return 0;
}

