/* Author: Andrei Grigorean
 * Time Complexity: O(N)
 */

#include <cstdio>
#include <cstring>

const int MAX_N = 1000005;
const int MOD = 8723609;
const int MOD2 = 9907;
const int MOD3 = 1031;
const int X = 13;
const int X2 = 17;
const int X3 = 10;

int n;
char s[MAX_N];

int main() {
  freopen("parpal.in", "r", stdin);
  freopen("parpal.out", "w", stdout);

  char t[10];
  gets(t);
  int test_no = 0;
  for (int i = 0; i < strlen(t); ++i)
    if ('0' <= t[i] && t[i] <= '9')
      test_no = test_no * 10 + (t[i] - '0');
    else
      break;

  for (int test = 0; test < test_no; ++test) {
    gets(s);
    n = strlen(s);
    if (n && s[n-1] == '\r') --n;

    int v1 = 0, v2 = 0, pow1 = 1;
    int u1 = 0, u2 = 0, pow2 = 1;
    int t1 = 0, t2 = 0, pow3 = 1;
    int last = 0;

    for (int i = 0; i < n; ++i) {
      v1 = (v1 * X + s[i]);
      if (v1 >= MOD) v1 %= MOD;
      v2 = (v2 + pow1 * s[i]);
      if (v2 >= MOD) v2 %= MOD;
      pow1 = (pow1 * X);
      if (pow1 >= MOD) pow1 %= MOD;

      /*
      u1 = (u1 * X2 + s[i]);
      if (u1 >= MOD2) u1 %= MOD2;
      u2 = (u2 + pow2 * s[i]);
      if (u2 >= MOD2) u2 %= MOD2;
      pow2 = (pow2 * X2);
      if (pow2 >= MOD2) pow2 %= MOD2;
      */

      if ((i & 1) && (v1 == v2) && (u1 == u2) && (t1 == t2)) {
        v1 = v2 = u1 = u2 = t1 = t2 = 0;
        pow1 = pow2 = pow3 = 1;
        last = i;
      }
    }
    printf("%s\n", ((last == n-1) && (n >= 2)) || (n == 0) ? "DA" : "NU");
  }
}


