/*
 * N ^3
 * Dragus Marius Ioan
 * */

#include<algorithm>
#include<stdio.h>
#include<assert.h>
const int maxn = 350;
using namespace std;

int N,P,D[maxn][maxn];
int INV[maxn];



int main()
{
	freopen("ubergraf.in","r",stdin);
	freopen("ubergraf.out","w",stdout);
	scanf("%d %d\n",&N,&P);
	int ver = 1;
	for(int i = 2;i < P; ++i)
		if (P % i == 0) ver = 0;
	assert(ver == 1);
	D[1][1] = 1;
	for(int i = 1;i <= N; ++i)
		for(int j = 1;j <= P; ++j)
			if ((i *j) % P == 1) INV[i] = j;
	for(int i = 1;i <= N; ++i)
		for(int j = 1;j <= i; ++j)
		{
			int put = 1,put2 = 1,m1 = 0,lim = 0;
			for(int p = 1;p <= j; ++p,put = (put * 2) % P,m1 = max(put - 1,m1));
			--put;
			if (put < 0) put += P;
			for(int p = 1;p <= i - j; ++p,put = (put * 2) % P,m1 = max(put,m1));
			if (i - j <= 10 && j <= 10) lim = (1 << (i - j)) * ((1 << j) - 1);
				else lim = N;
			put2 = put;			
			for(int k = 1;k <= N - i && k <= lim ; ++k)
			{
				D[i + k][k] = (D[i + k][k] + ((long long)D[i][j] * put2) % P) % P;		
				--put;
				if (put < 0) put += P;
				put2 = ((long long)put2 * put * INV[k + 1]) % P;	
			}
		}
	int sol = 0;
	for(int i = 1;i <= N; ++i)
		sol = (sol + D[N][i]) % P;
	printf("%d\n",sol);

	return 0;
}


