/*
 * Author: Cosmin Gheorghe
 * Time complexity: O(N^2)
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>

#define NMAX 100010
#define LL long long

int N, M;

int xc[NMAX], yc[NMAX], rc[NMAX];
int xp[NMAX], yp[NMAX];

int rez[NMAX];

int verif(int p, int c)
{
	LL dst = (LL) (xc[c] - xp[p]) * (xc[c] - xp[p]) + (LL) (yc[c] - yp[p]) * (yc[c] - yp[p]);

	return dst <= (LL) rc[c] * rc[c];
}

int main()
{
	int i, j;

	freopen("nuke.in", "r", stdin);
	freopen("nuke.out", "w", stdout);

	assert(scanf("%d %d", &N, &M) == 2);


	for (i = 1; i <= N; i++) {
		assert(scanf("%d %d", &xp[i], &yp[i]) == 2);
	}

	for (i = 1; i <= M; i++) {
		assert(scanf("%d %d %d", &xc[i], &yc[i], &rc[i]) == 3);

		for (j = 1; j <= N; j++) rez[i] += verif(j, i);

		printf("%d\n", rez[i]);
	}

/*	for (i = 1; i <= M; i++)
		for (j = i + 1; j <= M; j++) {
			LL dst = ((LL)xc[i] - xc[j]) * ((LL)xc[i] - xc[j]) + ((LL)yc[i] - yc[j]) * ((LL)yc[i] - yc[j]);
			if (dst <= ((LL)rc[i] + rc[j]) * (rc[i] + rc[j])) {
				printf("jeeeeeeeeeeeeeeeeeeeeeeeeeeeeeg %d %d\n", i, j);
				return 0;
			}
		}
*/

	return 0;
}

