#include <fstream>
#include <algorithm>

using namespace std;

#define Nmax 51
#define Inf 0x3f//3f3f3f

char best[2][8][Nmax][Nmax][Nmax];
int P = 0;
int a[Nmax][Nmax]; //1 daca pokemonul i il bate pe pokemonul j
int n,m; //nr de pokemoni , nr de pokemasteri
int P1, P2, P3; //pokemoni initiali

typedef struct { int p[3]; } pokemingi;
									
pokemingi inamic[2*Nmax];

//pt debug
//ofstream debug("log.txt");


void read() {
	ifstream fin("pokemon.in");
	
	fin >> n >> m;
	
	fin >> P1 >> P2 >> P3;
	
	for (int i = 1; i <= n; ++i)
	for (int j = 1; j <= n; ++j)
		fin >> a[i][j];
	
	for (int i = 1; i <= m; ++i)
		fin >> inamic[i].p[0] >> inamic[i].p[1] >> inamic[i].p[2];
	
	fin.close();
}

inline pokemingi makeBall(int p1, int p2, int p3) {
	pokemingi ret;
	ret.p[0] = p1;
	ret.p[1] = p2;
	ret.p[2] = p3;
	return ret;
}

inline bool bate(pokemingi A, pokemingi B) {
	int pct = 0;
	for (int i = 0; i < 3; ++i)
		pct += a[A.p[i]][B.p[i]] - a[B.p[i]][A.p[i]];					
	return pct > 0;
}

void solve() {	
	//initializez
	memset(best, 0x3f, sizeof best);
	best[0][0][P1][P2][P3] = 0;
	
	//bag dinamica
	for (int pokemaster = 1; pokemaster <= m; ++pokemaster, P ^= 1) {
		for (int mask = 0; mask < 8; ++mask) 
			for (int p1 = 1; p1 <= n; ++p1)
				for (int p2 = 1; p2 <= n; ++p2) 
					for (int p3 = 1; p3 <= n; ++p3) 
						best[P^1][mask][p1][p2][p3] = Inf;
			
		for (int i = 0; i < 2; ++i)
			for (int mask = 0; mask < 8; ++mask) 
				for (int p1 = 1; p1 <= n; ++p1)
					for (int p2 = 1; p2 <= n; ++p2) 
						for (int p3 = 1; p3 <= n; ++p3) 
						if (best[P][mask][p1][p2][p3] != Inf) {
							
							//debug << "[" << p1 << "," << p2 << "," << p3 << "," << mask << "," << pokemaster << "] = " << best[p1][p2][p3][mask][P] << "\n";
							
							int cost, pnou;
							
							//schimb primul pokemon						
							if ((mask & 1) == 0)
								cost = 1;
							else
								cost = 0;
								
							pnou = (p1 + 1);
							if (pnou > n)
								pnou -= n;					
							
							if (best[P][mask|1][pnou][p2][p3] > best[P][mask][p1][p2][p3] + cost)
								best[P][mask|1][pnou][p2][p3] = best[P][mask][p1][p2][p3] + cost;
							//schimb al doilea
							if ((mask & 2) == 0)
								cost = 1;
							else
								cost = 0;

							pnou = (p2 + 1);
							if (pnou > n)
								pnou -= n;
							
							if (best[P][mask|2][p1][pnou][p3] > best[P][mask][p1][p2][p3] + cost)
								best[P][mask|2][p1][pnou][p3] = best[P][mask][p1][p2][p3] + cost;
							//schimb al treilea
							if ((mask & 4) == 0)
								cost = 1;
							else
								cost = 0;

							pnou = (p3 + 1);
							if (pnou > n)
								pnou -= n;
							
							if (best[P][mask|4][p1][p2][pnou] > best[P][mask][p1][p2][p3] + cost)
								best[P][mask|4][p1][p2][pnou] = best[P][mask][p1][p2][p3] + cost;
								
							//daca il bat merg la urmatoare lupta
							
							if (bate(makeBall(p1,p2,p3), inamic[pokemaster]))
							if (best[P^1][0][p1][p2][p3] > best[P][mask][p1][p2][p3])
								best[P^1][0][p1][p2][p3] = best[P][mask][p1][p2][p3];
						}
	}
}

void write() {
	ofstream fout("pokemon.out");
	
	int ret = Inf;
	
	for (int p1 = 1; p1 <= n; ++p1)
		for (int p2 = 1; p2 <= n; ++p2)
			for (int p3 = 1; p3 <= n; ++p3)
				if (ret > best[P][0][p1][p2][p3])
					ret = best[P][0][p1][p2][p3];
					
	fout << ret << "\n";	
	
	fout.close();
}

int main() {
	read();
	solve();
	write();
	
						
	//debug.close();
	
	return 0;
}
