#include <fstream>
#include <algorithm>

using namespace std;

#define Nmax 51
#define Mmax 128
#define Inf 0x3f3f3f3f

int best[Nmax][Nmax][Nmax][2], P = 0;
int a[Nmax][Nmax]; //1 daca pokemonul i il bate pe pokemonul j
int n,m; //nr de pokemoni , nr de pokemasteri
int P1, P2, P3; //pokemoni initiali

typedef struct { int p[3]; } pokemingi;
									
pokemingi inamic[Mmax];

//pt debug
//ofstream debug("log.txt");


void read() {
	ifstream fin("pokemon.in");
	
	fin >> n >> m;
	
	fin >> P1 >> P2 >> P3;
	
	for (int i = 1; i <= n; ++i)
	for (int j = 1; j <= n; ++j)
		fin >> a[i][j];
	
	for (int i = 1; i <= m; ++i)
		fin >> inamic[i].p[0] >> inamic[i].p[1] >> inamic[i].p[2];
	
	fin.close();
}

inline pokemingi makeBall(int p1, int p2, int p3) {
	pokemingi ret;
	ret.p[0] = p1;
	ret.p[1] = p2;
	ret.p[2] = p3;
	return ret;
}

inline bool bate(pokemingi A, pokemingi B) {
	int pct = 0;
	for (int i = 0; i < 3; ++i)
		pct += a[A.p[i]][B.p[i]] - a[B.p[i]][A.p[i]];					
	return pct > 0;
}

void solve() {	
	//initializez
	memset(best, 0x3f, sizeof best);
	best[P1][P2][P3][0] = 0;
	
	//bag dinamica
	for (int pokemaster = 1; pokemaster <= m; ++pokemaster, P ^= 1) {
		for (int mask = 0; mask < 8; ++mask) 
			for (int p1 = 1; p1 <= n; ++p1)
				for (int p2 = 1; p2 <= n; ++p2) 
					for (int p3 = 1; p3 <= n; ++p3) 
						best[p1][p2][p3][P^1] = Inf;
			
		for (int i = 0; i < 2; ++i)
 				for (int p1 = 1; p1 <= n; ++p1)
					for (int p2 = 1; p2 <= n; ++p2) 
						for (int p3 = 1; p3 <= n; ++p3) 
						if (best[p1][p2][p3][P] != Inf) {
							
//							debug << "[" << p1 << "," << p2 << "," << p3 << "," << pokemaster << "] = " << best[p1][p2][p3][P] << "\n";
						
							//schimb primul pokemon													
							for (int pnou = 1; pnou <= n; ++pnou) 								
							if (best[pnou][p2][p3][P] > best[p1][p2][p3][P] + 1)
								best[pnou][p2][p3][P] = best[p1][p2][p3][P] + 1;
								
							//schimb al doilea
							for (int pnou = 1; pnou <= n; ++pnou) 								
							if (best[p1][pnou][p3][P] > best[p1][p2][p3][P] + 1)
								best[p1][pnou][p3][P] = best[p1][p2][p3][P] + 1;
							//schimb al treilea
							for (int pnou = 1; pnou <= n; ++pnou) 								
							if (best[p1][p2][pnou][P] > best[p1][p2][p3][P] + 1)
								best[p1][p2][pnou][P] = best[p1][p2][p3][P] + 1;
								
							//daca il bat merg la urmatoare lupta							
							if (bate(makeBall(p1,p2,p3), inamic[pokemaster]))
							if (best[p1][p2][p3][P^1] > best[p1][p2][p3][P])
								best[p1][p2][p3][P^1] = best[p1][p2][p3][P];
						}
	}
}

void write() {
	ofstream fout("pokemon.out");
	
	//raspunsul e in o stare de genul [p1, p2, p3, 0, m+1] ...
	
	int ret = Inf;
/*
	for (int p1 = 1; p1 <= n; ++p1)
		for (int p2 = 1; p2 <= n; ++p2)
			for (int p3 = 1; p3 <= n; ++p3)
				debug << "{" << p1 << "," << p2 << "," << p3 << "} = " << best[p1][p2][p3][0][m+1] << "\n";	
*/
	
	for (int p1 = 1; p1 <= n; ++p1)
		for (int p2 = 1; p2 <= n; ++p2)
			for (int p3 = 1; p3 <= n; ++p3)
				if (ret > best[p1][p2][p3][P])
					ret = best[p1][p2][p3][P];
					
	fout << ret << " - de la brut\n";	
	
	fout.close();
}

int main() {
	read();
	solve();
	write();
	
						
	//debug.close();
	
	return 0;
}
