/* Author: Puni Andrei Paul
 * Time Complexity: O(N)
 */

#include <stdio.h>
#include <string.h>

#define Nmax 2000100

int n, l[Nmax];
char x[Nmax/2], v[Nmax];

void solve() {
	memset(l, 0, Nmax);
	memset(v, 0, Nmax);
	
	
	fgets(x,Nmax,stdin);
	
	n = 1;
	v[1] = '*';

	for (int i = 0; x[i] >= 'a' && x[i] <= 'z'; ++i) {
		v[++n] = x[i];
		v[++n] = '*';		
	}

	int st=1, dr=3;
	l[2] = 1;

	for (int i = 3; i <= n; ++i) {
		if (i<=dr) {
			int poz = dr-i;
			if (i + l[st+poz] >= dr) {
				l[i] = dr-i;
				st = i - l[i];
				dr = i + l[i];
				while (v[st-1] == v[dr+1] && st > 1) {
					--st;
					++dr;
					++l[i];      
				}                                  
			} 
				else    
			l[i] = l[st+poz];
		}    
				 else
		{
			 l[i] = 0;
			 st = i;
			 dr = i;
			 while (v[st-1] == v[dr+1] && st > 1) {
				 --st;
				 ++dr;
				 ++l[i];      
			 }     
		}
	}

	int stanga = 1;
	for (int i = 2; i < n; ++i) 
		if ((i % 2 == 1) && (i > stanga) && (i - l[i] <= stanga)) 
			stanga = i + i - stanga;							
	
	if (stanga == n) {
		printf("DA\n");
	}	else {
		printf("NU\n");
	}

}

int main() {
	freopen("parpal.in","r",stdin);
	freopen("parpal.out","w",stdout);

	int t;
	
	scanf("%d\n", &t);
	
	while (t--)
		solve();

	return 0;    
}

