/*
	Dragus Marius Ioan
	suff array -complexitate O(Nlog^2(N))
*/

#include<stdio.h>
#include<vector>
#include<algorithm>
#define pb push_back
#define mkp make_pair

using namespace std;
const int maxl = 20;
const int maxn = 200100;

vector<pair<int,int> > VECT;
int MAT[maxl][maxn];
int N;
char S[maxn];

int cauta(vector<pair<int,int> > &v,int a,int b)
{
	int p = 1,x=0;
	int n = v.size();
	pair<int,int> p1 = mkp(a,b);
	for(p = 1;p < n; p <<= 1);
	for(;p;p >>= 1)
		if (x + p < n && v[x + p] <= p1) x += p;
	return x;
	
}

void print(int poz1,int poz2)
{
	for(int i = poz1;i <= poz2; ++i)
		printf("%c",S[i]);
	printf("\n");
}

void suffarray()
{
	for (int i = 1;i <= 2 * N + 1; ++i)
	{
		MAT[0][i] = S[i] - '$' + 1;
	}
	for(int p = 1;(1 << p) <= 2 * N + 1; ++p)
	{
		VECT.clear();
		for(int i = 1;i <= 2 * N + 1; ++i)
		{
			int aux = 0;
			if (i + (1 << (p - 1)) <= 2 * N + 1) aux = MAT[p - 1][i + (1 << (p - 1))];
			VECT.pb(mkp(MAT[p - 1][i],aux));
		}		
		sort(VECT.begin(),VECT.end());
		VECT.resize(unique(VECT.begin(),VECT.end()) - VECT.begin() );		
		for(int i = 1;i <= 2 * N + 1; ++i)
		{
			int aux = 0;
			if ((i + (1 << p)) <= 2 * N + 1) aux = MAT[p - 1][i + (1 << (p - 1))];
			MAT[p][i] = cauta(VECT,MAT[p - 1][i], aux );			
		}

	}
}

int lcp(int poz1,int poz2)
{
	int sol = 0,p = 0;
	for(p = 1;(1 << p) <= 2 * N + 1; p++);
	for(;p >= 0; --p)
	{
		if (poz1 + sol + (1 << p) > 2 * N + 1 || poz2 + sol + (1 << p) > 2 * N + 1) continue;
		if (MAT[p][poz1 + sol] == MAT[p][poz2 + sol]) sol += (1 << p); 	
	}
	return sol;
}

int main()
{
	freopen("parpal.in","r",stdin);
	freopen("parpal.out","w",stdout);	
	int nrt = 0;	
	scanf("%d\n",&nrt);
	for(;nrt; --nrt)
	{
		scanf("%s",S + 1);
		N = strlen(S + 1);
		S[N + 1] = '$';
		for(int i = N,p = N + 2;i;--i,++p )
			S[p] = S[i];
		suffarray();
		int poz = 1;
	//	print(1,2 * N + 1);
		for(int i = 2,i1 = 2 * N ;i <= N; i1 -= 2,i += 2)
		{
			if (poz + lcp(poz,i1) >= i) poz = i + 1;
/*			print(poz,poz + 5);
			print(i1,i1 + 5);
			printf("%d %d %d %d : %d\n",poz,i1,MAT[2][poz],MAT[2][i1],lcp(poz,i1));		
*/		}
		if (poz > N) printf("DA\n");
			else printf("NU\n");	
	}

	return 0;	
}


