//O(n^3)
#include <stdio.h>
#define DIM 1002
#include <string.h>
char S[DIM];
int i, j, k, N, L, T;
int A[DIM][DIM], B[DIM][DIM], P[DIM][DIM];
int C[DIM];

void drum(int i, int j) {
	if (B[i][j] == i) {
		C[++k] = i;
	}
	else {
		int M = B[i][j];
		drum(i, M-1);
		drum(M,j);
	}
}

int main(){
	FILE *f = fopen("parpal.in","r");
	FILE *g = fopen("parpal.out","w");
	fscanf(f,"%d\n",&T);
	for (;T;T--){ 
		fscanf(f,"%s",S);N = strlen(S);
		memset(A, 0, sizeof(A));
		memset(B, 0, sizeof(B));
		memset(P, 0, sizeof(P));
		for (i=0;i<=N-2;i++)
			if (S[i] == S[i+1]) {
				A[i][i+1] = 1;
				P[i][i+1] = 1;
				B[i][i+1] = i;
			}
			
		for (L = 4; L<=N; L+=2) {
			for (i=0; i<=N-1-L+1; i++) {
				j = i+L-1;
				if (P[i+1][j-1] && S[i] == S[j]){
					A[i][j] = 1;
					P[i][j] = 1;
					B[i][j] = i;
				} else {
					for (k = i+2;k<=j-1;k+=2)
						if (A[i][k-1] && A[k][j]) {
							A[i][j] = 1;
							B[i][j] = k;
						}
				}
			}
		}
		
		if (A[0][N-1])
			fprintf(g,"DA\n");
		else
			fprintf(g,"NU\n");
	}

	fclose(f);
	fclose(g);
	return 0;
}
